## saunafs 5.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

project(saunafs LANGUAGES C CXX)

set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_STANDARD 23)
set(CMAKE_C_STANDARD_REQUIRED ON)

# Enable symbol export for loadable modules, ensuring same shared resource
# references. Needed for the plugins, as they are shared libraries.
set(CMAKE_ENABLE_EXPORTS ON)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are disabled for this project. This is for your "
    "safety. To build the project, please create a build tree in "
    "a separate directory, for example:\n"
    "     mkdir ${CMAKE_SOURCE_DIR}/build\n"
    "     cd ${CMAKE_SOURCE_DIR}/build\n"
    "     cmake ..\n"
    "Before doing that you may need to clean up after this try by removing "
    "CMakeCache.txt file and CMakeFiles/ directory.\n"
    "If you REALLY need an in-source build, remove this check from "
    "${CMAKE_CURRENT_LIST_FILE} and try again."
  )
endif()

option(ENABLE_WERROR            "Enable treating compilation warnings as errors"         OFF)
option(ENABLE_LIGHTSFS          "Enable light version of SaunaFS"                       OFF)
option(ENABLE_UTILS             "Enable building additional binaries used e.g. in tests" OFF)
option(ENABLE_TESTS             "Enable building unit and functional tests"              OFF)
option(ENABLE_DOCS              "Enable building the documentation"                      ON)
option(ENABLE_EXIT_ON_USR1      "Enable handler for SIGUSR1 which calls exit()"          OFF)
option(THROW_INSTEAD_OF_ABORT   "Throw std::exception instead of calling abort"          OFF)
option(ENABLE_DEBUG_LOG         "Enable prefix based debug logs"                         OFF)
option(ENABLE_URAFT             "Enable installation of uraft util"                      ON)
option(ENABLE_VERBOSE_ASCIIDOC  "Enable verbose output of asciidoc"                      OFF)
option(ENABLE_TCMALLOC          "Enable use of tcmalloc-minimal library"                 OFF)
option(ENABLE_JEMALLOC          "Enable use of jemalloc library"                         OFF)
option(ENABLE_POLONAISE         "Enable polonaise"                                       ON)
option(ENABLE_CLIENT_LIB        "Enable dynamic client library (libsaunafs-client)"     OFF)
# end of SaunaFS options
option(ENABLE_TRACES            "Enable traces"                                          OFF)
option(ENABLE_SYSLOG_FOR_TRACES "Enable usage of syslog instead of stdout for traces"    OFF)
option(ENABLE_CRC               "Enable checksums"                                       ON)
option(ENABLE_REQUEST_LOG       "Enable logging request times"                           OFF)
option(USE_LEGACY_READ_MESSAGES "Enable sending old type of messages by mount"           OFF)
option(ENABLE_NFS_GANESHA       "Enable nfs-ganesha plugin"                              OFF)
option(ENABLE_CCACHE            "Enable ccache during compilation"                       ON)
option(ENABLE_NFS_ACL_SUPPORT   "Enable nfs-ganesha ACL support"                         ON)
option(ENABLE_COMPILE_COMMANDS  "Enable generation of compile_commands.json"             ON)
option(ENABLE_PROMETHEUS        "Enable prometheus metrics"                              ON)
# Experimental
option(ENABLE_INODE64           "Enable 64 bits for inode numbers and quantities"        OFF)
option(ENABLE_FOUNDATIONDB      "Enable FoundationDB experimental support"               OFF)

option(GENERATE_GIT_INFO "Generate git info from current repository (for version commands)" ON)

# If enabled (default), the file compile_commands.json is generated in the build
# directory. Tools like clangd and vscode use this file for proper analysis.
set(CMAKE_EXPORT_COMPILE_COMMANDS ${ENABLE_COMPILE_COMMANDS})

find_program(CCACHE_FOUND ccache)
message(STATUS "ENABLE_CCACHE: ${ENABLE_CCACHE}")
message(STATUS "CCACHE_FOUND: ${CCACHE_FOUND}")

if(ENABLE_CCACHE AND CCACHE_FOUND)
  set(CMAKE_C_COMPILER_LAUNCHER ccache)
  set(CMAKE_CXX_COMPILER_LAUNCHER ccache)
  message(STATUS "Using ccache")
endif()

set(DEFAULT_MIN_VERSION "5.1.2")

include(GNUInstallDirs)

set(BIN_SUBDIR                  "${CMAKE_INSTALL_FULL_BINDIR}")
set(SBIN_SUBDIR                 "${CMAKE_INSTALL_FULL_SBINDIR}")
set(LIB_SUBDIR                  "${CMAKE_INSTALL_FULL_LIBDIR}")
set(MAN_SUBDIR                  "${CMAKE_INSTALL_FULL_MANDIR}")
set(CGI_SUBDIR                  "${CMAKE_INSTALL_FULL_DATAROOTDIR}/sfscgi")
set(INCL_SUBDIR                 "${CMAKE_INSTALL_FULL_INCLUDEDIR}/saunafs")

set(ETC_SUBDIR                  "${CMAKE_INSTALL_FULL_SYSCONFDIR}/saunafs")
set(RUN_SUBDIR                  "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run/saunafs")
set(DATA_SUBDIR                 "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/saunafs")
set(USR_SHARE_DOC               "${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc/")
set(EXAMPLES_SUBDIR             "examples")
set(CHUNKSERVER_NAME            "saunafs-chunkserver")
set(CLIENT_NAME                 "saunafs-client")
set(METALOGGER_NAME             "saunafs-metalogger")
set(MASTER_NAME                 "saunafs-master")
set(URAFT_NAME                  "saunafs-uraft")
string(REGEX REPLACE "/$" "" USR_SHARE_DOC_NO_SLASH "${USR_SHARE_DOC}")
set(CHUNKSERVER_EXAMPLES_SUBDIR "${USR_SHARE_DOC_NO_SLASH}/${CHUNKSERVER_NAME}/${EXAMPLES_SUBDIR}")
set(CLIENT_EXAMPLES_SUBDIR      "${USR_SHARE_DOC_NO_SLASH}/${CLIENT_NAME}/${EXAMPLES_SUBDIR}")
set(METALOGGER_EXAMPLES_SUBDIR  "${USR_SHARE_DOC_NO_SLASH}/${METALOGGER_NAME}/${EXAMPLES_SUBDIR}")
set(SFSMASTER_EXAMPLES_SUBDIR   "${USR_SHARE_DOC_NO_SLASH}/${MASTER_NAME}/${EXAMPLES_SUBDIR}")
set(URAFT_EXAMPLES_SUBDIR       "${USR_SHARE_DOC_NO_SLASH}/${URAFT_NAME}/${EXAMPLES_SUBDIR}")

# Aliases
set(SBIN_PATH                   "${SBIN_SUBDIR}")
set(LIB_PATH                    "${LIB_SUBDIR}")
set(PLUGINS_PATH                "${LIB_PATH}/saunafs/plugins")
set(BUILD_PATH                  "${CMAKE_BINARY_DIR}")
set(CGI_PATH                    "${CGI_SUBDIR}")
set(ETC_PATH                    "${ETC_SUBDIR}")
set(DATA_PATH                   "${DATA_SUBDIR}")

set(DEFAULT_USER                 "saunafs"                 CACHE STRING "Default user to run daemons as")
set(DEFAULT_GROUP                "saunafs"                 CACHE STRING "Default group to run daemons as")
set(DEFAULT_MASTER_HOSTNAME      "sfsmaster"                CACHE STRING "Default master server hostname")
set(DEFAULT_MASTER_PORT          "9421"                     CACHE STRING "Default master server port number")
set(DEFAULT_MOUNTED_SUBFOLDER    "/"                        CACHE STRING "Default subfolder to be mounted")
set(DEFAULT_SFSMOUNT_CONFIG_PATH "${ETC_PATH}/sfsmount.cfg" CACHE STRING "Default full path to sfsmount configuration file")
set(SAUNAFS_BLOCKS_IN_CHUNK     "1024"                     CACHE STRING "Number of blocks in one chunk")
set(SAUNAFS_BLOCK_SIZE          "65536"                    CACHE STRING "Number of bytes in one block")

message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "DEFAULT_USER: ${DEFAULT_USER}")
message(STATUS "DEFAULT_GROUP: ${DEFAULT_GROUP}")
message(STATUS "SAUNAFS_BLOCKS_IN_CHUNK: ${SAUNAFS_BLOCKS_IN_CHUNK}")
message(STATUS "SAUNAFS_BLOCK_SIZE: ${SAUNAFS_BLOCK_SIZE}")
message(STATUS "ENABLE_WERROR: ${ENABLE_WERROR}")
message(STATUS "ENABLE_LIGHTSFS: ${ENABLE_LIGHTSFS}")
message(STATUS "ENABLE_UTILS: ${ENABLE_UTILS}")
message(STATUS "ENABLE_TESTS: ${ENABLE_TESTS}")
message(STATUS "ENABLE_DOCS: ${ENABLE_DOCS}")
message(STATUS "ENABLE_EXIT_ON_USR1: ${ENABLE_EXIT_ON_USR1}")
message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
message(STATUS "ENABLE_DEBUG_LOG: ${ENABLE_DEBUG_LOG}")
message(STATUS "ENABLE_VERBOSE_ASCIIDOC: ${ENABLE_VERBOSE_ASCIIDOC}")
message(STATUS "ENABLE_TCMALLOC: ${ENABLE_TCMALLOC}")
message(STATUS "ENABLE_JEMALLOC: ${ENABLE_JEMALLOC}")
message(STATUS "ENABLE_POLONAISE: ${ENABLE_POLONAISE}")
message(STATUS "ENABLE_CLIENT_LIB: ${ENABLE_CLIENT_LIB}")
message(STATUS "ENABLE_URAFT: ${ENABLE_URAFT}")
# end of SaunaFS options values
message(STATUS "ENABLE_TRACES: ${ENABLE_TRACES}")
message(STATUS "ENABLE_SYSLOG_FOR_TRACES: ${ENABLE_SYSLOG_FOR_TRACES}")
message(STATUS "ENABLE_CRC: ${ENABLE_CRC}")
message(STATUS "ENABLE_REQUEST_LOG: ${ENABLE_REQUEST_LOG}")
message(STATUS "USE_LEGACY_READ_MESSAGES: ${USE_LEGACY_READ_MESSAGES}")
message(STATUS "ENABLE_NFS_GANESHA: ${ENABLE_NFS_GANESHA}")
message(STATUS "ENABLE_COMPILE_COMMANDS: ${CMAKE_EXPORT_COMPILE_COMMANDS}")
message(STATUS "ENABLE_INODE64: ${ENABLE_INODE64}")
message(STATUS "ENABLE_FOUNDATIONDB: ${ENABLE_FOUNDATIONDB}")

if(ENABLE_INODE64)
  add_definitions(-DSAUNAFS_USE_INODE64)
endif()

if(ENABLE_TESTS)
  if(NOT THROW_INSTEAD_OF_ABORT)
    message(STATUS "Tests require THROW_INSTEAD_OF_ABORT to be set to YES, changing passed value:")
    set(THROW_INSTEAD_OF_ABORT YES)
    message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
  endif()
  if(NOT ENABLE_CLIENT_LIB)
    message(STATUS "Tests require ENABLE_CLIENT_LIB to be set to YES, changing passed value:")
    set(ENABLE_CLIENT_LIB YES)
    message(STATUS "ENABLE_CLIENT_LIB: ${ENABLE_CLIENT_LIB}")
  endif()
  set(BUILD_TESTS ON)
  set(BUILD_UTILS ON)
  set(SAUNAFS_ENABLE_DEBUG_LOG ON)
endif()

if(ENABLE_CLIENT_LIB)
  set(ENABLE_PIC_TARGETS ON)
endif()

if(CMAKE_BUILD_TYPE STREQUAL "coverage" OR CODE_COVERAGE)
  if("${CMAKE_C_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang" OR "${CMAKE_CXX_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
    message("Building with llvm Code Coverage Tools")
    find_program(LLVM_COV_PATH llvm-cov)
    if(NOT LLVM_COV_PATH)
      message(FATAL_ERROR "llvm-cov not found! Aborting.")
    endif()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-instr-generate -fcoverage-mapping")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-instr-generate -fcoverage-mapping")
  elseif("${CMAKE_C_COMPILER_ID}" MATCHES "GNU" OR "${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
    message("Building with lcov Code Coverage Tools")
    if(NOT (CMAKE_BUILD_TYPE STREQUAL "Debug"))
      message(WARNING "Code coverage results with an optimized (non-Debug) build may be misleading")
    endif()
    find_program(LCOV_PATH NAMES lcov lcov.bat lcov.exe lcov.perl)
    if(NOT LCOV_PATH)
      message(FATAL_ERROR "lcov not found! Aborting...")
    endif()
    find_program(GENHTML_PATH NAMES genhtml genhtml.perl genhtml.bat)
    if(NOT GENHTML_PATH)
      message(FATAL_ERROR "genhtml not found! Aborting...")
    endif()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage -fprofile-arcs -ftest-coverage")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage -fprofile-arcs -ftest-coverage")
  else()
    message(FATAL_ERROR "Code coverage requires Clang or GCC. Aborting.")
  endif()
endif()

string(TIMESTAMP BUILD_TIMESTAMP)
add_compile_definitions(BUILD_TIME="${BUILD_TIMESTAMP}")

if(VERSION_SUFFIX)
  set(PACKAGE_VERSION "${DEFAULT_MIN_VERSION}${VERSION_SUFFIX}")
else()
  set(PACKAGE_VERSION "${DEFAULT_MIN_VERSION}-dev")
endif()

string(REGEX MATCH "^([0-9]+)\\.([0-9]+)\\.([0-9]+)" PACKAGE_VERSION_MATCH ${PACKAGE_VERSION})
set(PACKAGE_VERSION_MAJOR ${CMAKE_MATCH_1})
set(PACKAGE_VERSION_MINOR ${CMAKE_MATCH_2})
set(PACKAGE_VERSION_MICRO ${CMAKE_MATCH_3})
message(STATUS "PACKAGE_VERSION: ${PACKAGE_VERSION}")
message(STATUS "PACKAGE_VERSION_MAJOR: ${PACKAGE_VERSION_MAJOR}")
message(STATUS "PACKAGE_VERSION_MINOR: ${PACKAGE_VERSION_MINOR}")
message(STATUS "PACKAGE_VERSION_MICRO: ${PACKAGE_VERSION_MICRO}")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m64")
endif()

if(GIT_COMMIT)
  add_compile_definitions(GIT_COMMIT="${GIT_COMMIT}")
elseif(GENERATE_GIT_INFO)

=== doc/CMakeLists.txt ===
if(NOT A2X_BINARY)
  message(WARNING "Program 'a2x' not found, manpages won't be generated")
  return()
endif()

# These manpages should be generated
set(MANPAGES
    saunafs.7
    saunafs-admin.8
    saunafs-cgiserver.8
    saunafs-probe.8          # not a source
    saunafs-uraft.8
    saunafs-uraft-helper.8
    saunafs-uraft.cfg.5
    saunafs-appendchunks.1
    saunafs-checkfile.1
    saunafs-dirinfo.1
    saunafs-fileinfo.1
    saunafs-filerepair.1
    saunafs-geteattr.1
    saunafs-seteattr.1       # not a source
    saunafs-deleattr.1       # not a source
    saunafs-getgoal.1
    saunafs-setgoal.1        # not a source
    saunafs-rgetgoal.1       # not a source
    saunafs-rsetgoal.1       # not a source
    saunafs-gettrashtime.1
    saunafs-settrashtime.1   # not a source
    saunafs-rgettrashtime.1  # not a source
    saunafs-rsettrashtime.1  # not a source
    saunafs-makesnapshot.1
    saunafs-rremove.1
    sfsmount.1
    saunafs-repquota.1
    saunafs-setquota.1       # not a source
    saunafs.1
    sfsglobaliolimits.cfg.5
    sfsiolimits.cfg.5
    sfschunkserver.cfg.5
    sfsexports.cfg.5
    sfsgoals.cfg.5
    sfshdd.cfg.5
    sfsmaster.cfg.5
    sfsmetalogger.cfg.5
    sfsmount.cfg.5
    sfstopology.cfg.5
    sfsmetadump.8
    sfsrestoremaster.8
    sfs.7                     # not a source
    sfschunkserver.8
    saunafs-migrations.7
    sfsmaster.8
    sfsmetalogger.8
    sfsmetarestore.8
)

# Create custom directory to store the a2x logs
set(A2X_LOGS_DIR ${CMAKE_CURRENT_BINARY_DIR}/a2x)
execute_process(COMMAND mkdir -p ${A2X_LOGS_DIR})

foreach(MANPAGE ${MANPAGES})
  get_filename_component(MANPAGE_SRC ${CMAKE_CURRENT_SOURCE_DIR}/${MANPAGE}.adoc ABSOLUTE)
  set(GENERATED_MANPAGE_PATH ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE})
  if(ENABLE_VERBOSE_ASCIIDOC)
    set(ASCIIDOC_VERBOSE --verbose --keep-artifacts)
  else()
    set(ASCIIDOC_VERBOSE)
  endif()
  if(EXISTS ${MANPAGE_SRC})
    set(MANPAGE_SRC_SYMLINK ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE}.txt)
    add_custom_command(OUTPUT ${GENERATED_MANPAGE_PATH}
        COMMAND ln -s -f ${MANPAGE_SRC} ${MANPAGE_SRC_SYMLINK}
        # Grepping out 'invalid escape sequence' warnings due to asciidoc bug
        COMMAND a2x ${ASCIIDOC_VERBOSE} -L -f manpage ${MANPAGE_SRC_SYMLINK} 2>&1
            | grep -v 'invalid escape sequence' | tee ${A2X_LOGS_DIR}/${MANPAGE}.log
        DEPENDS ${MANPAGE_SRC})
    set(GENERATED_MANPAGES ${GENERATED_MANPAGES} ${GENERATED_MANPAGE_PATH})
  endif()
  string(REGEX MATCH "[0-9]$" SECTION_NUMBER ${MANPAGE})
  install(FILES ${GENERATED_MANPAGE_PATH} DESTINATION ${MAN_SUBDIR}/man${SECTION_NUMBER})
endforeach()

add_custom_target(manpages ALL SOURCES ${GENERATED_MANPAGES})

=== external/CMakeLists.txt ===
# crcutil

if(NOT CRCUTIL_FOUND)
  if(HAVE_CRCUTIL)
    include_directories(${CRCUTIL_INCLUDE_DIRS})
    # Option -w disables warnings during CRC compilation
    # We do not plan to fix the external code
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CRCUTIL_CXX_FLAGS} -w")
    file(GLOB CRCUTIL_SOURCES ${CRCUTIL_SOURCE_DIR}/*.cc)
    shared_add_library(crcutil ${CRCUTIL_SOURCES})
  endif()
endif()

=== tests/CMakeLists.txt ===
# Create automatically generated list of test cases

if ( NOT ( ENABLE_POLONAISE AND POLONAISE_FOUND ) )
  set ( filter_out "|" "grep" "-v" "polonaise" )
endif ()
add_custom_target(list_of_test_cases
  COMMAND ls ${CMAKE_CURRENT_SOURCE_DIR}/test_suites
    | xargs -IXXX echo "class XXX : public BashTestingSuite {};"
    > test_suites.h.tmp
  COMMAND ${CMAKE_COMMAND} -E copy_if_different test_suites.h.tmp test_suites.h

  COMMAND cd ${CMAKE_CURRENT_SOURCE_DIR} && bash tools/generate_tests_from_templates.sh

  COMMAND find -L ${CMAKE_CURRENT_SOURCE_DIR}/test_suites/ -name test_*.sh
    ${filter_out}
    | sed -e "s/[.]sh$//"
    | awk -F/ "{print $(NF-1) \",\" $NF}"
    | xargs -IXXX echo "add_test_case(XXX)"
    > test_cases.h.tmp
  COMMAND ${CMAKE_COMMAND} -E copy_if_different test_cases.h.tmp test_cases.h

  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  VERBATIM)
set_source_files_properties(saunafs-tests.cc PROPERTIES
  OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/test_cases.h
  OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/test_suites.h)

# Create constants.sh file
configure_file(set_saunafs_constants.sh.in set_saunafs_constants.sh @ONLY)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/set_saunafs_constants.sh DESTINATION ${BIN_SUBDIR})

# Build executable running all the test cases
include_directories(${CMAKE_CURRENT_BINARY_DIR}) # test_cases.h is located here
add_definitions(-DTEST_DATA_PATH=${CMAKE_CURRENT_SOURCE_DIR})
add_executable(saunafs-tests saunafs-tests.cc)
add_dependencies(saunafs-tests list_of_test_cases)
target_link_libraries(saunafs-tests GTest::gtest GTest::gtest_main)
target_link_libraries(saunafs-tests ${Boost_SYSTEM_LIBRARY} ${Boost_FILESYSTEM_LIBRARY})
install(TARGETS saunafs-tests RUNTIME DESTINATION ${BIN_SUBDIR})

=== utils/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR})

install(PROGRAMS cpp-interpreter.sh DESTINATION ${BIN_SUBDIR})

# a library which causes pread/pwrite/close on chunks to return EIO
add_library(chunk_operations_eio SHARED chunk_operations_eio.c)
if(NOT CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  target_link_libraries(chunk_operations_eio dl)
endif()
install(TARGETS chunk_operations_eio DESTINATION ${LIB_SUBDIR})

# converter to xor chunks
add_executable(chunk_converter chunk_converter.cc)
target_link_libraries(chunk_converter ${ZLIB_LIBRARY})
install(TARGETS chunk_converter RUNTIME DESTINATION ${BIN_SUBDIR})

# crc converter
add_executable(crc_converter crc_converter.cc)
target_link_libraries(crc_converter ${ZLIB_LIBRARY})
install(TARGETS crc_converter RUNTIME DESTINATION ${BIN_SUBDIR})

# redirecting bind library
add_library(redirect_bind SHARED redirect_bind.c)
if(NOT CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  target_link_libraries(redirect_bind dl)
endif()
install(TARGETS redirect_bind DESTINATION ${LIB_SUBDIR})

# test files generator
add_executable(file-generate file_generate.cc)
install(TARGETS file-generate RUNTIME DESTINATION ${BIN_SUBDIR})

# test files generator which overwrites existing files
add_executable(file-overwrite file_overwrite.cc)
install(TARGETS file-overwrite RUNTIME DESTINATION ${BIN_SUBDIR})

# test files validator
add_executable(file-validate file_validate.cc)
install(TARGETS file-validate RUNTIME DESTINATION ${BIN_SUBDIR})

# test files validator
add_executable(file-validate-growing file_validate_growing.cc)
install(TARGETS file-validate-growing RUNTIME DESTINATION ${BIN_SUBDIR})

# utility for flock() system call
add_executable(flockcmd flockcmd.cc)
install(TARGETS flockcmd RUNTIME DESTINATION ${BIN_SUBDIR})

# utility for posix locks
add_executable(posixlockcmd posixlockcmd.cc)
install(TARGETS posixlockcmd RUNTIME DESTINATION ${BIN_SUBDIR})

# ping client
add_executable(sfsping sfs_ping.cc)
target_link_libraries(sfsping sfscommon)
install(TARGETS sfsping RUNTIME DESTINATION ${BIN_SUBDIR})

# ping server
add_executable(sfspingserv sfs_pingserv.cc)
target_link_libraries(sfspingserv sfscommon)
install(TARGETS sfspingserv RUNTIME DESTINATION ${BIN_SUBDIR})

# ping pong fcntl lock test
add_executable(safs_ping_pong ping_pong.cc)
install(TARGETS safs_ping_pong RUNTIME DESTINATION ${BIN_SUBDIR})

# readdir-unlink loop for readdir() testing
add_executable(readdir-unlink-test readdir_unlink_test.cc)
install(TARGETS readdir-unlink-test RUNTIME DESTINATION ${BIN_SUBDIR})

# big_session_metadata_benchmark test for testing sessions with large amount of files open
add_executable(big-session-metadata-benchmark big_session_metadata_benchmark.cc)
install(TARGETS big-session-metadata-benchmark RUNTIME DESTINATION ${BIN_SUBDIR})

if(ENABLE_FOUNDATIONDB)
  # sfs-test-fdb Checks if the expected FDB database is operable
  add_executable(sfs-test-fdb sfs_test_fdb.cc)
  target_link_libraries(sfs-test-fdb slogger fdb)
  install(TARGETS sfs-test-fdb RUNTIME DESTINATION ${BIN_SUBDIR})
endif()

add_library(slow_chunk_scan SHARED slow_chunk_scan.c)
if(NOT CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  target_link_libraries(slow_chunk_scan dl)
endif()
install(TARGETS slow_chunk_scan DESTINATION ${LIB_SUBDIR})

=== src/admin/CMakeLists.txt ===
collect_sources(SAUNAFS_ADMIN)

add_library(saunafs-admin-lib ${SAUNAFS_ADMIN_SOURCES})
target_link_libraries(saunafs-admin-lib sfscommon)
create_unittest(saunafs-admin-lib ${SAUNAFS_ADMIN_TESTS})
link_unittest(saunafs-admin-lib sfscommon)

if(ICON_RESOURCE_FILE STREQUAL "")
  add_executable(saunafs-admin ${SAUNAFS_ADMIN_MAIN})
else()
  add_executable(saunafs-admin ${SAUNAFS_ADMIN_MAIN} ${ICON_RESOURCE_FILE})
endif()
target_link_libraries(saunafs-admin saunafs-admin-lib)
install(TARGETS saunafs-admin RUNTIME DESTINATION ${BIN_SUBDIR})

if(NOT MINGW)
  add_custom_target(saunafs-probe ALL
    COMMAND ln -sf saunafs-admin saunafs-probe
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS saunafs-admin)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/saunafs-probe DESTINATION ${BIN_SUBDIR})
endif()

=== src/cgi/CMakeLists.txt ===
configure_file(saunafs-cgiserver.py.in   saunafs-cgiserver)
configure_file(chart.cgi.in    chart.cgi)
configure_file(sfs.cgi.in      sfs.cgi)

set(CGI_FILES err.gif favicon.ico favicon.svg index.html logomini.svg logomini.png sfs.css)
set(CGI_SCRIPTS
    ${CMAKE_CURRENT_BINARY_DIR}/sfs.cgi
    ${CMAKE_CURRENT_BINARY_DIR}/chart.cgi)
set(CGI_SERVERS
    ${CMAKE_CURRENT_BINARY_DIR}/saunafs-cgiserver)

install(FILES ${CGI_FILES} DESTINATION ${CGI_SUBDIR})
install(PROGRAMS ${CGI_SCRIPTS} DESTINATION ${CGI_SUBDIR})
install(PROGRAMS ${CGI_SERVERS} DESTINATION ${SBIN_SUBDIR})

=== src/chunkserver/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DSAUNAFS_MAX_FILES=10000)
add_definitions(-DAPPNAME=sfschunkserver -DAPP_EXAMPLES_SUBDIR="${CHUNKSERVER_EXAMPLES_SUBDIR}")

add_subdirectory(chunkserver-common)
add_subdirectory(plugins)

collect_sources(CHUNKSERVER)
add_library(chunkserver ${CHUNKSERVER_SOURCES})
target_link_libraries(chunkserver chunkserver-common safsprotocol sfscommon
    ${ADDITIONAL_LIBS})
create_unittest(chunkserver ${CHUNKSERVER_TESTS})
link_unittest(chunkserver chunkserver sfscommon)

add_executable(sfschunkserver ${MAIN_SRC})
target_link_libraries(sfschunkserver chunkserver ${PAM_LIBRARIES})

if(SYSTEMD_FOUND)
  target_link_libraries(sfschunkserver ${SYSTEMD_LIBRARIES})
endif()

install(TARGETS sfschunkserver RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/common/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(COMMON)

if(MINGW)
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/lockfile.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/memory_mapped_file.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/metadata.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/scoped_timer.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/setup.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/loop_watchdog.cc")
endif()

if(ISAL_LIBRARY)
  list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/galois_field_isal.cc")
  list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/galois_field_encode.cc")
endif()


shared_add_library(sfscommon ${COMMON_SOURCES})
shared_target_link_libraries(sfscommon STATIC sfserr SHARED sfserr_pic)
shared_target_link_libraries(sfscommon STATIC slogger SHARED slogger_pic)

if (HAVE_CRCUTIL)
  # Use crcutil Library
  include_directories(SYSTEM ${CRCUTIL_INCLUDE_DIRS}) # skip compiler warnings for external crcutil headers
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CRCUTIL_CXX_FLAGS}")
  shared_target_link_libraries(sfscommon ${CRCUTIL_LIBRARIES})
endif()
if (ZLIB_FOUND)
  shared_target_link_libraries(sfscommon ${ZLIB_LIBRARIES})
endif()
if (RT_LIBRARY)
  shared_target_link_libraries(sfscommon ${RT_LIBRARY})
endif()
if(TCMALLOC_LIBRARY AND ENABLE_TCMALLOC)
  message(STATUS "tcmalloc found, using it from: ${TCMALLOC_LIBRARY}")
  shared_target_link_libraries(sfscommon ${TCMALLOC_LIBRARY})
endif()
if(JEMALLOC_LIBRARY AND ENABLE_JEMALLOC)
  message(STATUS "jemalloc found, using it from: ${JEMALLOC_LIBRARY}")
  shared_target_link_libraries(sfscommon ${JEMALLOC_LIBRARY})
endif()
if(SOCKET_FOUND)
  shared_target_link_libraries(sfscommon ${SOCKET_LIBRARIES})
endif()
if(ISAL_LIBRARY)
  shared_target_link_libraries(sfscommon STATIC ${ISAL_LIBRARY} SHARED ${ISAL_PIC_LIBRARY})
endif()
if(JUDY_LIBRARY)
  shared_target_link_libraries(sfscommon ${JUDY_LIBRARY})
endif()

create_unittest(sfscommon ${COMMON_TESTS} ../master/goal_config_loader.cc)
link_unittest(sfscommon sfscommon)

set(PAM_D_DIR "${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d")
install(DIRECTORY DESTINATION "${PAM_D_DIR}")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/saunafs" "session required pam_limits.so")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/saunafs" DESTINATION "${PAM_D_DIR}")

=== src/config/CMakeLists.txt ===
collect_sources(CONFIG)

shared_add_library(config ${CONFIG_SOURCES})
shared_target_link_libraries(config ${YAML_CPP_LIBRARIES})

=== src/data/CMakeLists.txt ===
configure_file(sfsmaster.cfg.in sfsmaster.cfg)
configure_file(sfschunkserver.cfg.in sfschunkserver.cfg)
configure_file(sfsmetalogger.cfg.in sfsmetalogger.cfg)
configure_file(postinst.in postinst)
set(POSTINST_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/postinst PARENT_SCOPE)

install(FILES metadata.sfs                                   DESTINATION ${DATA_SUBDIR} RENAME metadata.sfs.empty)
install(FILES sfsexports.cfg                                 DESTINATION ${SFSMASTER_EXAMPLES_SUBDIR})
install(FILES sfsgoals.cfg                                   DESTINATION ${SFSMASTER_EXAMPLES_SUBDIR})
install(FILES sfshdd.cfg                                     DESTINATION ${CHUNKSERVER_EXAMPLES_SUBDIR})
install(FILES sfsmount.cfg                                   DESTINATION ${CLIENT_EXAMPLES_SUBDIR})
install(FILES sfsiolimits.cfg                                   DESTINATION ${CLIENT_EXAMPLES_SUBDIR})
install(FILES sfstopology.cfg                                DESTINATION ${SFSMASTER_EXAMPLES_SUBDIR})
install(FILES sfsglobaliolimits.cfg                             DESTINATION ${SFSMASTER_EXAMPLES_SUBDIR})
install(FILES saunafs-uraft.cfg                             DESTINATION ${URAFT_EXAMPLES_SUBDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/sfsmaster.cfg      DESTINATION ${SFSMASTER_EXAMPLES_SUBDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/sfschunkserver.cfg DESTINATION ${CHUNKSERVER_EXAMPLES_SUBDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/sfsmetalogger.cfg  DESTINATION ${METALOGGER_EXAMPLES_SUBDIR})

install(FILES saunafs.completion DESTINATION etc/bash_completion.d RENAME saunafs)

if(BUILD_TESTS)
  # Create a mock include dir.
  # We do this because we want to preserve the proper include directives in the example code
  # and still build this example program in the build step before the needed headers are installed.
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include/saunafs)
  add_custom_command(
    OUTPUT
      ${CMAKE_CURRENT_BINARY_DIR}/include/saunafs/saunafs_c_api.h
      ${CMAKE_CURRENT_BINARY_DIR}/include/saunafs/saunafs_error_codes.h
    COMMAND ${CMAKE_COMMAND} -E create_symlink
      ${CMAKE_SOURCE_DIR}/src/mount/client/saunafs_c_api.h
      ${CMAKE_CURRENT_BINARY_DIR}/include/saunafs/saunafs_c_api.h
    COMMAND ${CMAKE_COMMAND} -E create_symlink
      ${CMAKE_SOURCE_DIR}/src/errors/saunafs_error_codes.h
      ${CMAKE_CURRENT_BINARY_DIR}/include/saunafs/saunafs_error_codes.h
  )
  add_executable(c-client-example
    libsaunafs-client-example.c
    ${CMAKE_CURRENT_BINARY_DIR}/include/saunafs/saunafs_c_api.h
    ${CMAKE_CURRENT_BINARY_DIR}/include/saunafs/saunafs_error_codes.h)
  target_include_directories(c-client-example PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/include)
  target_link_libraries(c-client-example saunafs-client stdc++ m)
  install(TARGETS c-client-example RUNTIME DESTINATION ${BIN_SUBDIR})
endif()

=== src/errors/CMakeLists.txt ===
collect_sources(SFSERR)

shared_add_library(sfserr ${SFSERR_SOURCES})

=== debian/changelog ===
saunafs (5.1.2-1ubuntu1) resolute; urgency=medium

  * Fix FTBFS (LP: #2142100)
  * Fix filelimits using wrong user
  * Fix sleep not stopping chunkserver
  * Replace references of LizardFS to SaunaFS in remaining files

 -- Urmas Rist <urmas@urist.ee>  Tue, 17 Feb 2026 17:03:05 +0000

saunafs (5.1.2-1) unstable; urgency=medium

  * Initial release (Closes: #1080956)

 -- Urmas Rist <urmas@urist.ee>  Thu, 28 Aug 2025 16:32:26 +0000

=== debian/control ===
Source: saunafs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian HPC Team <debian-hpc@lists.debian.org>
Uploaders: Urmas Rist <urmas@urist.ee>
Section: admin
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               bash-completion,
               python3,
               cmake,
               asciidoc,
               libxml2-utils,
               docbook-xml,
               docbook-xsl,
               xsltproc,
               pkgconf,
# libcrcutil is for little-endian architectures only.
               libcrcutil-dev [!hppa !m68k !mips !powerpc !powerpcspe !ppc64 !s390 !s390x !sparc !sparc64],
               libfuse3-dev,
               libdb-dev,
               libyaml-cpp-dev,
               prometheus-cpp-dev,
#_beware:     ,libgoogle-perftools-dev
               googletest,
               libisal-dev [amd64 kfreebsd-amd64],
               libjudy-dev,
               libpam-dev,
               libspdlog-dev,
               libsystemd-dev [!kfreebsd-any],
#             ,libthrift-dev
               zlib1g-dev,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libfmt-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/hpc-team/saunafs
Vcs-Git: https://salsa.debian.org/hpc-team/saunafs.git
Homepage: https://saunafs.com/
Rules-Requires-Root: no

# Vcs-Browser: https://salsa.debian.org/debian/saunafs
# Vcs-Git: https://salsa.debian.org/debian/saunafs.git
Package: saunafs-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         adduser
Description: SaunaFS - common files
 Files and users common for all SaunaFS applications.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-master
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
# TODO: Source version should generally be equal
         saunafs-common (>= ${source:Version})
Built-Using: ${my:Built-Using}
Description: SaunaFS - master server
 SaunaFS master (metadata) server.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-metalogger
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         saunafs-common (>= ${source:Version})
Built-Using: ${my:Built-Using}
Description: SaunaFS - metalogger server
 SaunaFS metadata replication (backup) server.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-chunkserver
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         saunafs-common (>= ${source:Version})
Built-Using: ${my:Built-Using}
Description: SaunaFS - data server
 The SaunaFS data server.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-client
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: fuse
Built-Using: ${my:Built-Using}
Description: SaunaFS - client tools and mount utility
 SaunaFS FUSE mount utility "sfsmount" and client tool "saunafs".
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
  master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-adm
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Built-Using: ${my:Built-Using}
Description: SaunaFS - administration tools
 SaunaFS administration tool: saunafs-admin
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-cgiserv
Architecture: any
Depends: ${misc:Depends},
#       ,saunafs-cgi
         saunafs-common (>= ${source:Version}),
         python3-legacy-cgi,
         python3
Built-Using: ${my:Built-Using}
Description: simple CGI-capable HTTP server to run SaunaFS CGI monitor
 Simple standalone CGI-capable HTTP server to run SaunaFS CGI Monitor.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-uraft
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
#       ,saunafs-cgi
         saunafs-common (>= ${source:Version}),
         saunafs-adm (>= ${source:Version}),
         saunafs-master (>= ${source:Version})
Built-Using: ${my:Built-Using}
Description: Raft-like algorithm tool for SaunaFS
 HA tool based on the Raft algorithm.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/leil-io/saunafs/tags \
  .*/tags/v?\.?(\d[\d\.]+)\.tar\.gz
